﻿namespace UltraGridEmptyRowsEvents
{
    using System;
    using System.Data;
    using System.Diagnostics;
    using System.Windows.Forms;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
            new Infragistics.Win.UIElementViewer.UIElementViewerForm().Show();
            this.Load += Form1_Load;
            this.ultraGrid1.MouseEnterElement += UltraGrid1_MouseEnterElement;
            this.ultraGrid1.MouseLeaveElement += UltraGrid1_MouseLeaveElement;
            this.ultraGrid1.ClickCell += UltraGrid1_ClickCell;
        }

        private void UltraGrid1_ClickCell(object sender, ClickCellEventArgs e)
        {
            Debug.WriteLine("Cell on row {0} was clicked", e.Cell.Row.Index);
        }

        private void UltraGrid1_MouseLeaveElement(object sender, UIElementEventArgs e)
        {
            if(e.Element is EmptyRowsAreaUIElement)
            {
                //  If the mouse leaves the empty rows area enable all the grid events
                this.ultraGrid1.EventManager.AllEventsEnabled = true;
            }
        }

        private void UltraGrid1_MouseEnterElement(object sender, UIElementEventArgs e)
        {
            if(e.Element is EmptyRowsAreaUIElement)
            {
                //  If the mouse enters empty rows area disable all grid events. Enable only
                //  MouseLeaveElement event in order to be able to restore grid events state
                //  when mouse leave the empty rows area
                //
                this.ultraGrid1.EventManager.AllEventsEnabled = false;
                this.ultraGrid1.EventManager.SetEnabled(GridEventIds.MouseLeaveElement, true);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = this.GetData();
            this.ultraGrid1.DisplayLayout.EmptyRowSettings.ShowEmptyRows = true;
        }

        private DataTable GetData(int rows = 20, int cols = 5)
        {
            DataTable dt = new DataTable();

            for(int col = 0; col < cols; col++)
            {
                dt.Columns.Add(string.Format("Column #{0}", col + 1));
            }

            for(int row = 0; row < rows; row++)
            {
                DataRow addRow = dt.NewRow();
                foreach(DataColumn column in dt.Columns)
                {
                    addRow[column] = string.Format("{0}.{1}", row + 1, column.Ordinal + 1);
                }

                dt.Rows.Add(addRow);
            }

            return dt;
        }
    }
}
